package com.vendor.burn.ui.dialog;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Messages;
import com.vendor.burn.model.BoardConfig;
import com.vendor.burn.preferences.FastbootPreferences;
import java.util.List;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.viewers.IBaseLabelProvider;
import org.eclipse.jface.viewers.IContentProvider;
import org.eclipse.jface.viewers.IDoubleClickListener;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;

public class ConfigDialog extends Dialog {
  static String[] columnNames = new String[] { Messages.FastbootView_MacAddress, Messages.FastbootView_IPAddress, Messages.FastbootView_SubnetMask, Messages.FastbootView_Gateway };
  
  private static final int DELETED_ID = 1025;
  
  private TableViewer tableViewer;
  
  private Table table;
  
  private List<BoardConfig> boardConfigs;
  
  private BoardConfig boardConfig = null;
  
  public ConfigDialog(Shell parentShell) {
    super(parentShell);
  }
  
  protected Control createDialogArea(Composite parent) {
    parent.getShell().setText(Messages.BoardConfig_Dialog);
    Composite area = (Composite)super.createDialogArea(parent);
    this.tableViewer = new TableViewer(area, 67584);
    this.table = this.tableViewer.getTable();
    this.table.setLayoutData(new GridData(4, 4, true, true, 1, 1));
    this.table.setLinesVisible(true);
    this.table.setHeaderVisible(true);
    for (int i = 0; i < columnNames.length; i++) {
      TableColumn columnName = new TableColumn(this.table, 16777216);
      columnName.setWidth(150);
      columnName.setAlignment(16777216);
      columnName.setText(columnNames[i]);
    } 
    this.tableViewer.setLabelProvider((IBaseLabelProvider)new Object(this));
    this.tableViewer.setContentProvider((IContentProvider)new Object(this));
    this.tableViewer.addDoubleClickListener((IDoubleClickListener)new Object(this));
    this.tableViewer.setInput(createInput());
    if (this.table.getItemCount() > 0)
      this.table.select(0); 
    return (Control)area;
  }
  
  protected void handleDoubleClick() {
    buttonPressed(0);
  }
  
  private List<BoardConfig> createInput() {
    return this.boardConfigs = BoardConfig.load();
  }
  
  protected void buttonPressed(int buttonId) {
    IStructuredSelection selection = (IStructuredSelection)this.tableViewer.getSelection();
    if (buttonId == 0 && 
      !selection.isEmpty())
      setBoardConfig((BoardConfig)selection.getFirstElement()); 
    if (buttonId == 1025)
      handleDelete(); 
    super.buttonPressed(buttonId);
  }
  
  private void handleDelete() {
    IStructuredSelection selection = (IStructuredSelection)this.tableViewer.getSelection();
    BoardConfig firstElement = (BoardConfig)selection.getFirstElement();
    this.boardConfigs.remove(firstElement);
    this.tableViewer.refresh();
    if (this.table != null && 
      this.table.getItemCount() > 0)
      this.table.select(0); 
    FastbootPreferences.CONFIG.setClientWholeConfig(BoardConfig.save(this.boardConfigs));
  }
  
  protected void initializeBounds() {
    super.initializeBounds();
    getShell().pack();
    Point size = new Point(650, 400);
    getShell().setSize(size);
  }
  
  protected void createButtonsForButtonBar(Composite parent) {
    createButton(parent, 0, Messages.ConfigDialog_OK, false);
    createButton(parent, 1025, Messages.ConfigDialog_Delete, false);
    createButton(parent, 1, Messages.ConfigDialog_Cancel, false);
  }
  
  public BoardConfig getBoardConfig() {
    return this.boardConfig;
  }
  
  public void setBoardConfig(BoardConfig boardConfig) {
    this.boardConfig = boardConfig;
  }
}
